package tutorial.module.complex;
import adf.agent.info.*;
import adf.component.module.complex.BuildingDetector;
import adf.agent.module.ModuleManager;
import adf.agent.develop.DevelopData;
import rescuecore2.standard.StandardConstants;
import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;
import java.util.*;
import java.util.Random;

public class AITBuildingDetector extends BuildingDetector
{
    private EntityID result;
  
    public AITBuildingDetector(
        AgentInfo ai, WorldInfo wi, ScenarioInfo si,
        ModuleManager mm, DevelopData dd)
    {
        super(ai, wi, si, mm, dd);
    }

    @Override
    public EntityID getTarget()
    {
        return this.result;
    }

    @Override
    public BuildingDetector calc()  
    {
        EntityID me = this.agentInfo.getID();
        Set<EntityID> changed = this.worldInfo.getChanged().getChangedEntities(); 
        List<EntityID> list_HEAT = new ArrayList<>();  //燃焼度1の建物を格納するリスト
        List<EntityID> list_BURN = new ArrayList<>();  //燃焼度2の建物を格納するリスト

        this.result = null;  //resultを初期化

        for (EntityID id : changed)
        {
            StandardEntity entity = this.worldInfo.getEntity(id);
            boolean isBuilding = entity instanceof Building;
            if (isBuilding)
            {
                Building building = (Building)entity;
                boolean isBurning = building.isOnFire();
                StandardEntityConstants.Fieryness fieryness = building.getFierynessEnum();
                if(isBurning)
                {
                    if(StandardEntityConstants.Fieryness.HEATING == fieryness) {  //燃焼度1
                        list_HEAT.add(id);  //燃焼度1の建物を格納
                    } else if (StandardEntityConstants.Fieryness.BURNING == fieryness) {  //燃焼度2
                        list_BURN.add(id);  //燃焼度2の建物を格納
                    } 
                }
            }  
        }
        
        if(list_HEAT.size() >= 1) {  //燃焼度1の建物が1つ以上ある場合
            Random random = new Random(1);
            EntityID random_HEAT = list_HEAT.get(random.nextInt(list_HEAT.size()));
            this.result = random_HEAT;
            System.out.println(random_HEAT);
            return this;
        }

        if(list_BURN.size() >= 1) {  //燃焼度2の建物が1つ以上ある場合
            Random random = new Random(1);
            EntityID random_BURN = list_BURN.get(random.nextInt(list_BURN.size()));
            this.result = random_BURN;
        }

        if (list_HEAT.size() == 0 && list_BURN.size() == 0) {  //燃焼度1の建物も燃焼度2の建物もない場合
            //nullを返す
        }
        return this;
    }
}
