package tutorial.module.complex;
import adf.agent.info.*;
import adf.component.module.complex.Search;
import adf.component.module.algorithm.Clustering;
import adf.agent.module.ModuleManager;
import adf.agent.develop.DevelopData;
import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;

import java.sql.Array;
import java.sql.SQLOutput;
import java.util.*;

public class AITSearch extends Search
{
    private EntityID result;
    private Random random = new Random(1);
    private Clustering clustering;

    private List<EntityID> wentList = new ArrayList<>();
    private EntityID will = null;
    private int idx;
    private int changeCluster = 0;
    private int stayTime = 0;
    private double prev_x = 0;
    private double prev_y = 0;

    public AITSearch(
            AgentInfo ai, WorldInfo wi, ScenarioInfo si,
            ModuleManager mm, DevelopData dd)
    {
        super(ai, wi, si, mm, dd);

        String clusteringKey = "SampleSearch.Clustering";
        switch (ai.me().getStandardURN()) {
            case FIRE_BRIGADE:
                clusteringKey += ".Fire";
                break;
            case AMBULANCE_TEAM:
                clusteringKey += ".Ambulance";
                break;
            case POLICE_FORCE:
                clusteringKey += ".Police";
                break;
        }

        this.clustering = mm.getModule(clusteringKey, "adf.sample.module.algorithm.SampleKMeans");
        this.registerModule(this.clustering);
    }

    @Override
    public EntityID getTarget()
    {
        return this.result;
    }

    @Override
    public Search calc()
    {
        EntityID me = this.agentInfo.getID();
        List<EntityID> list = new ArrayList<>(this.getBuildingCluster(me));
        EntityID nowPos = this.agentInfo.getPosition();
        double me_x = this.agentInfo.getX();
        double me_y = this.agentInfo.getY();
        int n = list.size();

        if(will == null) {
            will = list.get(this.random.nextInt(n));
        }

        if(nowPos.equals(will)) {
            wentList.add(will);
            will = list.get(this.random.nextInt(n));
            for(EntityID ls : wentList) {
                if(ls.equals(will)) {
                    will = list.get(this.random.nextInt(n));
                    continue;
                }
            }
            if(wentList.size() == n) {
                wentList.clear();
                changeCluster = 1;
            }
        }
        if(this.getDistance(me_x, me_y, prev_x, prev_y) < 1000) {
            stayTime++;
            if(2 < stayTime) {
                will = list.get(this.random.nextInt(n));
                stayTime = 0;
            }
            for(EntityID ls : wentList) {
                if(ls.equals(will)) {
                    will = list.get(this.random.nextInt(n));
                    continue;
                }
            }
        } else {
            stayTime = 0;
        }
        prev_x = me_x;
        prev_y = me_y;
        this.result = will;
        System.out.println(me + " : " + will + "   "  + "now : " + nowPos + " wentListSize : " + wentList.size() + " listSize : " + n + " changeCluster : " + changeCluster + " idx : " + idx);
        return this;
    }

    private List<EntityID> getBuildingCluster(EntityID me) {
        if(changeCluster == 0) {
            idx = this.clustering.getClusterIndex(me);
            changeCluster = -1;
        } else if(changeCluster == 1) {
            idx = this.random.nextInt(clustering.getClusterNumber());
            changeCluster = -1;
        }
        Collection<StandardEntity> cluster = this.clustering.getClusterEntities(idx);
        List<EntityID> buildingCluster = new ArrayList<>();
        for(StandardEntity en : cluster) {
            if(en instanceof Building) {
                buildingCluster.add(en.getID());
            }
        }
        return buildingCluster;
    }

    private double getDistance(double me_x, double me_y, double prev_x, double prev_y) {
        return Math.sqrt(Math.pow(prev_x - me_x, 2) + Math.pow(prev_y - me_y, 2));
    }
}