package tutorial.module.complex;
import adf.agent.info.*;
import adf.component.module.complex.Search;
import adf.component.module.algorithm.Clustering;
import adf.agent.module.ModuleManager;
import adf.agent.develop.DevelopData;
import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;

import java.awt.*;
import java.util.*;
import java.util.List;

public class AITSearch_pf extends Search
{
    private EntityID result;
    private Random random = new Random(1);
    private Clustering clustering;
    private EntityID destination;//目的地
    List<EntityID> check = new ArrayList<>();//既にいった目的地かどうか

    double beforeX;//前のX座標
    double beforeY;//前のY座標

    int idx;

    public AITSearch_pf(
            AgentInfo ai, WorldInfo wi, ScenarioInfo si,
            ModuleManager mm, DevelopData dd)
    {
        super(ai, wi, si, mm, dd);

        String clusteringKey = "SampleSearch.Clustering";
        switch (ai.me().getStandardURN())
        {
            case FIRE_BRIGADE:
                clusteringKey += ".Fire";
                break;
            case AMBULANCE_TEAM:
                clusteringKey += ".Ambulance";
                break;
            case POLICE_FORCE:
                clusteringKey += ".Police";
                break;
        }

        this.clustering =
                mm.getModule(clusteringKey,
                        "adf.sample.module.algorithm.SampleKMeans");
        this.registerModule(this.clustering);
    }

    @Override
    public EntityID getTarget()
    {
        return this.result;
    }

    @Override
    public Search calc()
    {
//        System.out.println("start");

        EntityID me = this.agentInfo.getID();//自身のIDを取得

        int n, r;

        EntityID position = this.agentInfo.getPosition();//自身の場所のIDを取得


        idx = this.clustering.getClusterIndex(me);//自身に関連したクラスタの番号を取得
        Collection<EntityID> cluster =
                this.clustering.getClusterEntityIDs(idx);//クラスタ内のIDのリストを作成

        // 擬似乱数を用いてランダムに選択するために，Listに変換します
        List<EntityID> list = new ArrayList<>(cluster);

        System.out.println(check.size());


        if(check.size() == list.size())//クラスタ内のIDを全て探索した場合
        {
            idx = this.random.nextInt(clustering.getClusterNumber());
            cluster = this.clustering.getClusterEntityIDs(idx);//クラスタ内のIDのリストを作成

            // 擬似乱数を用いてランダムに選択するために，Listに変換します
            list = new ArrayList<>(cluster);
        }


        if(destination == null)//初回
        {

            // 擬似乱数を用いてランダムに選択します
            n = list.size();
            r = this.random.nextInt(n);//ランダムな数字

            this.result = list.get(r);//行先決定
            destination = list.get(r);//目的地設定

            beforeX = 0;
            beforeY = 0;
        }


        if(destination.equals(position))//目的地についたかどうか
        {
            System.out.println("0");
            boolean breakcheck = true;//既にいった行先と被っていなければtrue

            check.add(destination);//既に行ったかリストに今着いた目的地を追加

            n = list.size();// 擬似乱数を用いてランダムに選択します
            while (true)
            {
                breakcheck = true;//既にいった行先と被っていなければtrue


                r = this.random.nextInt(n);//ランダムな数字

                for(EntityID tmp:check)//既にいった行先と被ってないか確認
                {
                    if(tmp.equals(list.get(r)))
                    {
                        breakcheck = false;//既にいった行先と被ったのでfalse
                        break;
                    }
                }

                if(breakcheck)//既にいった行先と被っていなければループを抜け出せる
                {
                    break;
                }
            }

            this.result = list.get(r);//行先決定
            destination = list.get(r);//目的地設定

        }else {
            //目的地についてないので行先はそのまま
            this.result = destination;



            //位置が変わらなかったら目標を変更したい
            //現在の位置（座標）を記録
            double nowX = this.agentInfo.getX();
            double nowY = this.agentInfo.getY();
//            System.out.println(nowX + " now " + nowY);
//            System.out.println(beforeX+" before "+beforeY);

            //比較

            if(beforeX == nowX && beforeY == nowY)
            {
                //変わらなかったら目的地をランダムに
                boolean breakcheck = true;//既にいった行先と被っていなければtrue

                check.add(destination);//既に行ったかリストに今着いた目的地を追加

                n = list.size();// 擬似乱数を用いてランダムに選択します
                while (true)
                {

                    r = this.random.nextInt(n);//ランダムな数字

                    for(EntityID tmp:check)//既にいった行先と被ってないか確認
                    {

                        if(tmp.equals(r))
                        {
                            breakcheck = false;//既にいった行先と被ったのでfalse
                            break;
                        }
                    }

                    if(breakcheck)//既にいった行先と被っていなければループを抜け出せる
                    {
                        break;
                    }

                }

                this.result = list.get(r);//行先決定
                destination = list.get(r);//目的地設定
            }
        }


        //前の位置（座標）を記録
        beforeX = this.agentInfo.getX();
        beforeY = this.agentInfo.getY();

//        System.out.println(beforeX+" before "+beforeY);
//        System.out.println("end");

        return this;
    }
}